////////////////////////////////////
//  RainyDay.java
//
//  This code was created for the 3nd Java Applet Coding Contest at http://www.cfxweb.net/
//
//  If anybody can find something usefull in this code please use it and let me know.
//
//  Bob.
//  hk@dgmr.nl
//  http://home.kabelfoon.nl/~rhordijk
///////////////////////////////////////

package rainyday;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.image.*;

public class RainyDay extends Applet implements Runnable {
  boolean isStandalone = false;
  private Thread thread;
  private int lWidth, lHeight;
  private int lSize;
  private long firstFrame, frames = 0, fps = 0;

  private Image bgimage;
  private int[] bgdata;
  private String bgName;

  private Image fgimage;
  private int[] fgdata;
  private String fgName;
  private int fgHeight, fgWidth;

  private Image workimage;
  private int[] workdata;
  private int[] workdata2;

  private long starttime;

  private int barwidth = 15;
  private int[] window;

  private NoiseMap nm;
  private int NoiseMapHeight = 20;

  private int BlobSize = 31;
  private int nrBlob = 80;
  private BlobPos[] Blobs;
  private int[] BlobBuf;
  private int[] BlobMap;

  private int[] pal;
  private int ScrollHeight = 30;
  private int [] ScrollFixed;

  private boolean bShowBg = true;
  private boolean bShowRain = true;
  private boolean bShowBlob = true;
  private boolean bShowFg = false;
  private boolean bShowFrame = true;
  private boolean bShowScrollText = false;
  private boolean bShowFps = false;

  /**Get a parameter value*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /**Construct the applet*/
  public RainyDay() {
  }

  private void loadimages(){
    int [] srcpx;

    Image si;
    try {
      si = getImage(getDocumentBase(), bgName );
    } catch (Exception e) {
      si = null;
    }

    if ((si == null) || (bgName == "")) {
      for(int i = 0; i < lHeight; i++){
        for(int j = 0; j < lWidth; j++){
          if (((i % 25) > 5) && ((j % 25) > 5)) {
            bgdata[i*lWidth + j] = 0xFF007700;
          } else {
            bgdata[i*lWidth + j] = 0xFF000077;
          }
        }
      }
    } else {
      while (si.getHeight(null) == -1) { }; // wait on loading image
      PixelGrabber pg = new PixelGrabber(si, (si.getWidth(null) - lWidth)/2, (si.getHeight(null)- lHeight)/2, lWidth, lHeight, true);
      try {
        pg.grabPixels();
      } catch (InterruptedException e ) {
        System.err.println(e);
      }
      bgdata = (int []) pg.getPixels();
    }

    try {
      fgimage = getImage(getDocumentBase(), fgName );
    } catch (Exception e) {
      fgimage = null;
    }

    if ((fgimage == null) || (fgName == "")) {
      fgdata = new int[lWidth * lHeight];
      for(int i = 0; i < lHeight; i++){
        for(int j = 0; j < lWidth; j++){
          if (((i % 25) > 3) && ((j % 25) > 5)) {
            fgdata[i*lWidth + j] = 0xFFFFFFFF;
          } else {
            fgdata[i*lWidth + j] = 0xFF000000;
          }
        }
      }
      java.awt.image.MemoryImageSource memsrc = new MemoryImageSource(lWidth,lHeight,fgdata,0,lWidth);
      memsrc.setAnimated(true);
      memsrc.setFullBufferUpdates(true);
      fgimage = createImage(memsrc);
      fgHeight = lHeight;
      fgWidth = lWidth;
    } else {
      while (fgimage.getHeight(null) == -1) { }; // wait on loading image
      fgdata = new int[fgimage.getWidth(null) * fgimage.getHeight(null)];
      PixelGrabber pg = new PixelGrabber(fgimage, 0, 0, fgimage.getWidth(null), fgimage.getHeight(null), true);
      try {
        pg.grabPixels();
      } catch (InterruptedException e ) {
        System.err.println(e);
      }
      fgdata = (int []) pg.getPixels();
      fgHeight = fgimage.getHeight(null);
      fgWidth = fgimage.getWidth(null);
    }
  }

  private void BuildBlobMap() {
    BlobBuf = new int[2 * BlobSize * BlobSize];
    int [] tempBuf = new int[BlobSize * BlobSize];
    int HalfBlobSize = BlobSize/2;
    int OneAndHalfBlobSize = 3 * BlobSize/2;

    int h = BlobSize * 8;
    for(int x = 0; x < BlobSize; x++){
      for(int y = 0; y < BlobSize; y++){
        double d = 0.5 * BlobSize - Math.sqrt(Math.pow(x - 0.5 * BlobSize,2) + Math.pow(y - 0.5 * BlobSize,2));
        if (d < 0)
          d = 0;
        tempBuf[y * BlobSize + x] = (int)Math.round(h * (1 - Math.cos(2 * Math.PI * d/BlobSize)));
      }
    }
    for(int x = 0; x < BlobSize; x++){
      for(int y = 0; y < OneAndHalfBlobSize; y++){
        int fac1 = (y * tempBuf[HalfBlobSize * BlobSize + x])/OneAndHalfBlobSize;
        int fac2 = (int)(fac1 * Math.sin(1.57 * Math.pow(1 - Math.abs((double)(x - HalfBlobSize)/HalfBlobSize),3)));
        double scale = OneAndHalfBlobSize * Math.pow((double)y/OneAndHalfBlobSize,3);
        BlobBuf[y * BlobSize + x] = (int)(scale * fac1 + (OneAndHalfBlobSize - scale) * fac2)/OneAndHalfBlobSize;
      }

      for(int y = (3 * BlobSize) / 2; y < 2 * BlobSize; y++){
        BlobBuf[y * BlobSize + x] =  tempBuf[(y - BlobSize) * BlobSize + x];
      }
    }
  }

  private int valtocol(int val, double pos)
  {
    int col = val % 512;
    if (col > 255) {
      col = 511 - col;
    }
    col = (int) (255 * Math.pow(((double)col)/255, 2.0));
    // 88 56 28
    //236 172 116
    int r = ((col * 28) + (255 - col) * 116) >> 8;
    int g = ((col * 56) + (255 - col) * 172) >> 8;
    int b = ((col * 88) + (255 - col) * 236) >> 8;

    if (pos < 0) {
      double w = 2 * (pos + 1);
      if  (w > 1) {
        w = 2 - w;
      }
      w = 0.1 + 0.9 * Math.pow(1 - w, 0.8);
      r = (int)(r * w + 255 * (1 - w));
      g = (int)(g * w + 255 * (1 - w));
      b = (int)(b * w + 255 * (1 - w));
    } else {
      double w = 0.8 * (1 - pos);
      r = (int)(r * w);
      g = (int)(g * w);
      b = (int)(b * w);
    }
    col = 0xFF000000 + r + (g << 8) + (b << 16);
    return col;
  }

  private void BuildWindow() {

    for(int y = 0; y < barwidth; y++){
      for(int x = 0; x < lWidth; x++){
        window[((lHeight - barwidth)/2 + y) * lWidth + x] = valtocol(10000 + (x + y * 120) + nm.turbulence2Di(4 * x, 4 *y , 8),
                                                                    2.0 * (y - barwidth/2)/ barwidth);
      }
    }

    for(int y = 0; y < lHeight; y++){
      for(int x = 0; x < barwidth; x++){
        window[y * lWidth + x + (lWidth - barwidth)/2] = valtocol(10000 + (x * 120 + y) + nm.turbulence2Di(4 * x, 4 *y , 8),
                                                                      2.0 * (x - barwidth/2)/ barwidth  );
      }
    }

    for(int y = 0; y < lHeight; y++){
      for(int x = 0; x < barwidth; x++){
        double w = 2 + (double)(- 3 * x)/barwidth;
        if (w > 0) {
         w = 0;
        }
        window[y * lWidth + x] = valtocol(10000 + (x * 120 + y) + nm.turbulence2Di(4 * x, 4 *y , 8), -w);
        window[y * lWidth + lWidth - 1 - x] = valtocol(10000 + (x * 120 + y) + nm.turbulence2Di(4 * x, 4 *y , 8), w);
      }
    }

    for(int y = 0; y < barwidth; y++){
      for(int x = y; x < (lWidth-y); x++){
        double w = 2 + (double)(- 3 * y)/barwidth;
        if (w > 0) {
         w = 0;
        }
        window[y * lWidth + x] = valtocol(10000 + (x + y * 120) + nm.turbulence2Di(4 * x, 4 *y , 8), -w);
        window[(lHeight - 1 - y) * lWidth + x] = valtocol(10000 + (x + y * 120) + nm.turbulence2Di(4 * x, 4 *y , 8), w);
      }
    }
  }

  private void BuildPallete(){
    pal = new int[256];

    for(int i = 0; i < 256; i++){
      int r =  (int)Math.round(Math.pow(i/255.0,2)*255);
      int g =  (int)Math.round(Math.pow(i/255.0,2)*255);
      int b =  (int)Math.round(Math.pow(i/255.0,0.5)*255);
      pal[i] = (0xFF000000 + (r << 16) + (g << 8) + b);
    }
  }

  private void BuildScrollFixed(){
    ScrollFixed = new int[ScrollHeight * lWidth];

    for(int y = 0; y < ScrollHeight; y++){
      for(int x = 0; x < lWidth; x++){
        ScrollFixed[y * lWidth + x] = 20 * y + (int)Math.round(80 - Math.abs(80 * Math.sin(0.03 * y + 0.07 * x)));
       }
    }
  }

  /**Initialize the applet*/
  public void init() {
    try { lWidth = Integer.parseInt(this.getParameter("width", "256")); }
    catch(Exception e) { e.printStackTrace();}
    try { lHeight =  Integer.parseInt(this.getParameter("height", "256"));}
    catch(Exception e) { e.printStackTrace(); }
    try { bgName =  this.getParameter("bg", "");}
    catch(Exception e) { e.printStackTrace(); }
    try { fgName =  this.getParameter("fg", "");}
    catch(Exception e) { e.printStackTrace(); }
    try { jbInit(); }
    catch(Exception e) { e.printStackTrace(); }

    nm = new NoiseMap(lWidth , NoiseMapHeight);

    bgdata = new int[lWidth * lHeight];
    java.awt.image.MemoryImageSource memsrc = new MemoryImageSource(lWidth,lHeight,bgdata,0,lWidth);
    memsrc.setAnimated(true);
    memsrc.setFullBufferUpdates(true);
    bgimage = createImage(memsrc);

    loadimages();

    workdata = new int[lWidth * lHeight];
    java.awt.image.MemoryImageSource memsrc2 = new MemoryImageSource(lWidth,lHeight,workdata,0,lWidth);
    memsrc2.setAnimated(true);
    memsrc2.setFullBufferUpdates(true);
    workimage = createImage(memsrc2);

    workdata2 = new int[lWidth * lHeight];
    window = new int[lWidth * lHeight];

    lSize = lWidth * lHeight;
    BlobMap = new int[lSize];

    Blobs = new BlobPos[nrBlob];
    for(int i = 0; i < nrBlob; i++){
      Blobs[i] = new BlobPos(lWidth, lHeight, BlobSize);
    }

    BuildBlobMap();

    BuildWindow();

    BuildPallete();
    BuildScrollFixed();
    starttime =System.currentTimeMillis();
  }

   public void start() {
    if (thread == null) {
      thread = new Thread(this);
      thread.setPriority(Thread.MIN_PRIORITY);
      thread.start();
    }
  }

  public synchronized void stop() {
    if (thread != null) {
      thread.interrupt();
    }
    thread = null;
    notifyAll();
  }

  public void run() {
    Thread me = Thread.currentThread();
    me.setPriority(Thread.MIN_PRIORITY);

    while ((thread == me) && isShowing() && (getSize().width != 0)) {
      repaint();
      Thread.yield();
    }
    thread = null;
  }
/*
  private void ZoomZ()
  {
    int bufwidth = 2 * lWidth;
    int bufheight = NoiseMapHeight;
    int bufwidth8 = bufwidth << 8;
    int bufheight8 = bufheight << 8;

    int sx = bufwidth8 / lWidth;
    int sy = bufheight8 / lHeight;
    int syx = (-100 + 1000 * bufwidth8 ) % bufwidth8;
    int syy = (sy  + 1000 * bufheight8) % bufheight8;
    int sxx = (sx  + 1000 * bufwidth8 ) % bufwidth8;

    int bwx = 0;
    int wy = 0;
    int wx = bwx;

    int imgpos = 0;
    for(int y = 0; y < lHeight; y++){
      wx = bwx;
      int py = (wy >> 8) * bufwidth;
      for(int x = 0; x < lWidth; x++){
        int col = bgdata[imgpos];

        int nv = nm.Map[py + (wx >> 8)] ;
        int u = 256 - nv;
        int u1 = nv << 8;
        int r = ((((col & 0xFF0000) >> 16) * u + u1) << 8) & 0xFF0000;
        int g = (((col & 0x00FF00) >> 8) * u + u1)  & 0x00FF00;
        int b = ((col & 0x0000FF) * u + u1) >> 8;

        workdata[imgpos] = 0xFF000000 | r | g | b;
        imgpos++;

        wx += sxx;
        if (wx >= bufwidth8) {
          wx -= bufwidth8;
        }
      }
      wy += syy;
      bwx += syx;
      if (bwx >= bufwidth8) {
        bwx -= bufwidth8;
      }
    }
  }
*/
  private void ZoomZ2()
  {
    int bufwidth = 2 * lWidth;
    int bufheight = NoiseMapHeight;
    int bufwidth8 = bufwidth << 8;
    int bufheight8 = bufheight << 8;

    int sx = bufwidth8 / lWidth;
    int sy = bufheight8 / lHeight;
    int syx = (-100 + 1000 * bufwidth8 ) % bufwidth8;
    int syy = (sy  + 1000 * bufheight8) % bufheight8;
    int sxx = (sx  + 1000 * bufwidth8 ) % bufwidth8;

    int bwx = 0;
    int wy = 0;
    int wx = bwx;

    int imgpos = 0;
    int py,v,v1,u,u1,col,nv,r,g,b, nmpos;
    col = 0;
    for(int y = 0; y < lHeight; y++){
      wx = bwx;
      py = (wy >> 8) * bufwidth;
      v  = wy & 0xFF;
      v1 = 256 - v;
      for(int x = 0; x < lWidth; x++){
        u = wx & 0xFF;
        u1 = 256 - u;

        if (bShowBg) {
          col = bgdata[imgpos];
        }

        nmpos =  py + (wx >> 8);
        nv = (nm.Map[nmpos]                * u1  +
              nm.Map[nmpos + 1]            * u)  * v1 +
             (nm.Map[nmpos + bufwidth]     * u1  +
              nm.Map[nmpos + bufwidth + 1] * u) * v;

        nv = nv >> 16;
        u = 256 - nv;
        u1 = nv << 8;
        r = ((((col & 0xFF0000) >> 16) * u + u1) << 8) & 0xFF0000;
        g = (((col & 0x00FF00) >> 8) * u + u1)  & 0x00FF00;
        b = ((col & 0x0000FF) * u + u1) >> 8;

        workdata[imgpos] = 0xFF000000 | r | g | b;
        imgpos++;

        wx += sxx;
        if (wx >= bufwidth8) {
          wx -= bufwidth8;
        }
      }
      wy += syy;
      bwx += syx;
      if (bwx >= bufwidth8) {
        bwx -= bufwidth8;
      }
    }
  }

  private void FillBg()
  {
    int col = 0xFF000000;
    int imgpos = 0;
    for(int y = 0; y < lHeight; y++){
      for(int x = 0; x < lWidth; x++){
        if (bShowBg) {
          col = bgdata[imgpos];
        }
        workdata[imgpos] = col;
        imgpos ++;
      }
    }
  }

  private void SetBlobs()
  {
    for(int i = lSize -1; i > 0 ; i-- ){
      BlobMap[i] = 0;
    }

    for(int i = 0; i < nrBlob; i++){
      int YStart = Blobs[i].Yint;
      if (YStart < 0) {
        YStart = 0;
      }

      int YEnd = Blobs[i].Yint + 2 * BlobSize;
      if (YEnd >= lHeight) {
        YEnd = lHeight - 1;
      }
      int XStart = Blobs[i].Xint;
      if (XStart < 0) {
        XStart = 0;
      }

      int XEnd = Blobs[i].Xint + BlobSize;
      if (XEnd >= lWidth) {
        XEnd = lWidth - 1;
      }

      int LineInc = lWidth - XEnd + XStart;
      int BMPos = YStart * lWidth + XStart;

      int YBStart = YStart - Blobs[i].Yint;
      int YBEnd   = YEnd - Blobs[i].Yint;
      int XBStart = XStart - Blobs[i].Xint;
      int XBEnd   = XEnd - Blobs[i].Xint;

      int BlobLineInc = BlobSize - XBEnd + XBStart;
      int BBPos = YBStart * BlobSize + XBStart;

      int DY = YBEnd - YBStart;
      int DX = XBEnd - XBStart;

      for (int y = DY; y > 0; y--) {
        for (int x = DX; x > 0; x--) {
          BlobMap[BMPos++] += BlobBuf[BBPos ++];
        }
        BMPos += LineInc;
        BBPos += BlobLineInc;
      }
    }
  }

  private void DrawBlobs()
  {
    System.arraycopy(workdata,0,workdata2,0, lSize);

    int BlobLimit =  (int)Math.round(2.5 * BlobSize);
    int lightlevel = (int)Math.round(20 * BlobSize);
    int lightfac =   (int)Math.round(256 *  4.0 / BlobSize);

    int Offset = 1;
    if (bShowFrame) {
      Offset = barwidth;
    }

    for (int y = Offset; y < lHeight - Offset; y++) {
      for (int x = Offset; x < lWidth - Offset; x++) {
        if (BlobMap[y * lWidth + x] < BlobLimit) {
          continue;
        }

        int i = y * lWidth + x;
        int nx = BlobMap[i - lWidth + 1] + BlobMap[i + lWidth + 1] + BlobMap[i + 1] -
                 BlobMap[i - lWidth - 1] - BlobMap[i + lWidth - 1] - BlobMap[i - 1];
        int ny = BlobMap[i + lWidth - 1] + BlobMap[i + lWidth    ] + BlobMap[i + lWidth + 1] -
                 BlobMap[i - lWidth - 1] - BlobMap[i - lWidth    ] - BlobMap[i - lWidth + 1];

        int py = y + ny / 8;
        int px = x + nx / 8;

        int col = 0xFF000000;
        if (py < 0) {
          py = 0;
        } else if (py >= lHeight) {
          py = lHeight - 1;
        }
        if (px < 0) {
          px = 0;
        } else if (px >= lWidth) {
          px = lWidth - 1;
        }

        col = workdata2[py * lWidth + px];

        int light = (lightfac * ( lightlevel - BlobMap[i])) >> 8;
        if (light < 0) {
          light = 0;
        }

        int r = ((col & 0xFF0000) >> 16) + light;
        if (r > 255) {
          r = 0xFF0000;
        } else {
          r = r << 16;
       }
       int g = ((col & 0x00FF00) >> 8 ) + light;
        if (g > 255) {
          g = 0x00FF00;
        } else {
          g = g << 8;
        }
        int b = (col & 0xFF) + light;
        if (b > 255) {
          b = 0xFF;
        }

        col = 0xFF000000 | r | g | b;
        workdata[y * lWidth + x] = col;
      }
    }
  }

  private void AddWindow() {
    int Offset = (lHeight - barwidth)/2 * lWidth;
    for(int y = (lHeight - barwidth)/2; y < (lHeight - barwidth)/2 + barwidth; y++){
      for(int x = lWidth; x > 0; x--){
        workdata[Offset] = window[Offset];
        Offset ++;
      }
    }

    for(int y = 0; y < lHeight; y++){
      for(int x = (lWidth - barwidth)/2; x < (lWidth - barwidth)/2 + barwidth; x++){
        workdata[y * lWidth + x] = window[y * lWidth + x];
      }
    }

    for(int y = 0; y < lHeight; y++){
      for(int x = 0; x < barwidth; x++){
        workdata[y * lWidth + x] = window[y * lWidth + x];
        workdata[y * lWidth + lWidth - 1 - x] = window[y * lWidth + lWidth - 1 - x];
      }
    }

    Offset = 0;
    int Offset2 = lSize -1;
    for(int y = 0; y < barwidth; y++){
      for(int x = lWidth; x > 0; x--){
        workdata[Offset] = window[Offset];
        Offset++;
        workdata[Offset2] = window[Offset2];
        Offset2--;
      }
    }
  }

  private void Addfg() {
    int ymax = Math.min(fgHeight, lHeight);
    int xmax = Math.min(fgWidth, lWidth);
    int yoffset = Math.max(0, lHeight - ymax);
    int xoffset = Math.max(0, lWidth - xmax);
    int offset = yoffset * lWidth + xoffset;

    for(int y = 0; y < ymax; y++){
      for(int x = 0; x < xmax; x++){
        int c2 = fgdata[y * fgWidth + x];
        int c1 = workdata[y * lWidth + x + offset];
        int l = (((c2 & 0xFF0000) >> 16) + ((c2 & 0x00FF00) >> 8) + (c2 & 0x0000FF)) / 4;
        int l1 = 256 - l;

        int r = ((((c1 & 0xFF0000) >> 16) * l1 + ((c2 & 0xFF0000) >> 16) * l) << 8) & 0xFF0000;
        int g = (((c1 & 0x00FF00) >> 8) * l1   + ((c2 & 0x00FF00) >> 8) * l)  & 0x00FF00;
        int b = ((c1 & 0x0000FF) * l1          + (c2 & 0x0000FF) * l) >> 8;
        workdata[y * lWidth + x + offset] = 0xFF000000 | r | g | b;
      }
    }
  }

  private void AddScrollText() {
    int z = (int) (System.currentTimeMillis() - starttime) / 3;
    int imagepos = (lHeight - 2 * barwidth - ScrollHeight) * lWidth;
    int scrollpos = 0;
    int FadeSize = 15;

    for(int y = 0; y < FadeSize; y++){
      int yFade1 = (int)Math.round(Math.pow((double)y/FadeSize, 0.5)* FadeSize) + 1;
      int yFade2 = FadeSize + 1 - yFade1;
      for(int x = 0; x < lWidth; x++){
        int  v = Math.abs(nm.turbulence3Di(x * 6 - z / 2, y * 16, z, 4));
        v = 255 - (ScrollFixed[scrollpos ++] + (z >> 4) + (v >>1)) % 256;
        int r = (((workdata[imagepos] & 0xFF0000) * yFade2 + (pal[v] & 0xFF0000) * yFade1)/16) & 0xFF0000;
        int g = (((workdata[imagepos] & 0x00FF00) * yFade2 + (pal[v] & 0x00FF00) * yFade1)/16) & 0x00FF00;
        int b = (((workdata[imagepos] & 0x0000FF) * yFade2 + (pal[v] & 0x0000FF) * yFade1)/16) & 0x0000FF;
        workdata[imagepos++] = 0xFF000000 | r |g | b;
      }
    }

    for(int y = FadeSize; y < ScrollHeight - FadeSize; y++){
      for(int x = 0; x < lWidth; x++){
        int  v = Math.abs(nm.turbulence3Di(x * 6 - z / 2, y * 16, z, 4));
        v = 255 - (ScrollFixed[scrollpos ++] + (z >> 4) + (v >>1)) % 256;
        workdata[imagepos++] = pal[v];
      }
    }

    for(int y = ScrollHeight - FadeSize; y < ScrollHeight; y++){
      int yFade1 = (int)Math.round(Math.pow((double)(ScrollHeight - 1 - y)/FadeSize, 0.5) * FadeSize) + 1;
      int yFade2 = FadeSize + 1 - yFade1;
      for(int x = 0; x < lWidth; x++){
        int  v = Math.abs(nm.turbulence3Di(x * 6 - z / 2, y * 16, z, 4));
        v = 255 - (ScrollFixed[scrollpos ++] + (z >> 4) + (v >>1)) % 256;
        int r = (((workdata[imagepos] & 0xFF0000) * yFade2 + (pal[v] & 0xFF0000) * yFade1)/16) & 0xFF0000;
        int g = (((workdata[imagepos] & 0x00FF00) * yFade2 + (pal[v] & 0x00FF00) * yFade1)/16) & 0x00FF00;
        int b = (((workdata[imagepos] & 0x0000FF) * yFade2 + (pal[v] & 0x0000FF) * yFade1)/16) & 0x0000FF;
        workdata[imagepos++] = 0xFF000000 | r |g | b;
      }
    }
  }

  public void update(Graphics g) {
    nm.UpdateNoiseMap(1);
    if (bShowRain) {
      ZoomZ2();
    } else {
      FillBg();
    }

    if (bShowBlob) {
      for(int i = 0; i < nrBlob; i++){
        Blobs[i].step();
      }
      SetBlobs();
      DrawBlobs();
    }

    if (bShowFg) {
      Addfg();
    }

    if (bShowFrame) {
      AddWindow();
    }

    if (bShowScrollText){
      AddScrollText();
    }

    workimage.flush();
    g.drawImage(workimage, 0,0, null);

    if (bShowScrollText){
      g.setColor(Color.yellow);
      g.setFont(new Font("Serif",Font.BOLD,16));
      int Offset = (int)(lWidth + ((starttime - System.currentTimeMillis())/ 40) % (750 + lWidth));
      int h = lHeight - 2 * barwidth - (ScrollHeight - 16)/2;
      g.drawString(" --- Rainy Day ---  Created August 2001 for the 3rd Java Applet Coding Contest at http://www.cfxweb.net/", Offset, h);
    }

    if ((System.currentTimeMillis() - firstFrame) < 1000) {
      frames++;
    } else {
      frames++;
      fps = (frames * 10000) / (System.currentTimeMillis() - firstFrame);
      firstFrame = System.currentTimeMillis();
      frames = 0;
    }
    if (bShowFps) {
      g.setColor(Color.white);
      g.drawString(fps/10 + "." + fps % 10 + " fps", 2, lHeight - 2);
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception {
    this.addKeyListener(new java.awt.event.KeyAdapter()
    {
      public void keyTyped(KeyEvent e)
      {
        this_keyTyped(e);
      }
    });
  }
  /**Get Applet information*/
  public String getAppletInfo() {
    return "Applet Information";
  }
  /**Get parameter info*/
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"width", "integer", ""},
      {"height", "integer", ""},
      {"bg", "string", ""},
      {"fg", "string", ""},
      };
    return pinfo;
  }
  /**Main method*/
  public static void main(String[] args) {
    RainyDay applet = new RainyDay();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame() {
      protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }
      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
    };
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(400,320);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  void this_keyTyped(KeyEvent e)
  {
    switch (e.getKeyChar()){
    case 'b':
    case 'B':
       bShowBg = !bShowBg;
       break;
    case 'r':
    case 'R':
       bShowRain = !bShowRain;
       break;
    case 'd':
    case 'D':
       bShowBlob = !bShowBlob;
       break;
    case 'w':
    case 'W':
       bShowFrame = !bShowFrame;
       break;
    case 'f':
    case 'F':
       bShowFg = !bShowFg;
       break;
    case 's':
    case 'S':
       bShowScrollText = !bShowScrollText;
       break;
    case 'p':
    case 'P':
       bShowFps = !bShowFps;
       break;
    case '1':
       BlobSize = 7;
       nrBlob = 1000;

       Blobs = new BlobPos[nrBlob];
       for(int i = 0; i < nrBlob; i++){
         Blobs[i] = new BlobPos(lWidth, lHeight, BlobSize);
       }

       BuildBlobMap();
       break;
    case '2':
       BlobSize = 15;
       nrBlob = 400;

       Blobs = new BlobPos[nrBlob];
       for(int i = 0; i < nrBlob; i++){
         Blobs[i] = new BlobPos(lWidth, lHeight, BlobSize);
       }

       BuildBlobMap();
       break;
    case '3':
       BlobSize = 31;
       nrBlob = 80;

       Blobs = new BlobPos[nrBlob];
       for(int i = 0; i < nrBlob; i++){
         Blobs[i] = new BlobPos(lWidth, lHeight, BlobSize);
       }

       BuildBlobMap();
       break;
    case '4':
       BlobSize = 63;
       nrBlob = 20;

       Blobs = new BlobPos[nrBlob];
       for(int i = 0; i < nrBlob; i++){
         Blobs[i] = new BlobPos(lWidth, lHeight, BlobSize);
       }

       BuildBlobMap();
       break;
    case '5':
       BlobSize = 127;
       nrBlob = 8;

       Blobs = new BlobPos[nrBlob];
       for(int i = 0; i < nrBlob; i++){
         Blobs[i] = new BlobPos(lWidth, lHeight, BlobSize);
       }

       BuildBlobMap();
       break;
    }
  }

}

